<template>
  <div class="repositories-menu">
    <div class="repos">
      <div
        class="repository"
        @click="
          $router.push({ query: { repository: repository.id } }) &&
            selectRepository(repository.id)
        "
        v-for="repository in project.repositories"
        :key="repository.id"
      >
        <transition name="fade" mode="out-in">
          <div
            class="selected"
            v-if="
              selectedRepository !== null &&
                selectedRepository.id === repository.id
            "
          ></div>
        </transition>
        <i class="fas fa-server"></i>{{ repository.displayName }}
      </div>
    </div>
    <div class="add">
      <div class="repository">
        <button class="button block" @click="createRepository">
          <i class="fas fa-plus"></i>Add Repository
        </button>
      </div>
    </div>
  </div>
</template>

<script>
import { mapMutations, mapState } from "vuex";
import CreateRepository from "../../../../components/modals/CreateRepository";
export default {
  computed: {
    ...mapState("projectModule", ["selectedRepository"])
  },
  props: {
    project: {
      required: true
    }
  },
  methods: {
    ...mapMutations("projectModule", ["selectRepository"]),
    createRepository() {
      this.$modal.show(CreateRepository, {
        project: this.project
      });
    }
  }
};
</script>

<style lang="scss">
.repositories-menu {
  width: 250px;
  height: 100vh;
  flex-basis: 250px;
  background-color: #eeeeee;
  border-right: 1px solid #c1c1c1;
  display: flex;
  flex-direction: column;
  .repos {
    flex: 1;
  }
  .repository {
    display: flex;
    align-items: center;
    font-weight: 600;
    border-bottom: 1px solid #dfdfdf;
    &:hover {
      cursor: pointer;
    }
    .selected {
      width: 10px;
      height: 10px;
      background-color: #7f00e2;
      border-radius: 100%;
      margin-right: 20px;
    }
    i {
      margin-right: 10px;
    }
    padding: 15px;
  }
}
#app {
  &.dark {
    .repositories-menu {
    }
  }
}
</style>
